#include<stdlib.h>
#include<fstream>
#include<iostream>
#include <LEDA/graphics/graphwin.h>
#include <LEDA/graph/graph.h>
#include <LEDA/graph/edge_array.h>
#include <LEDA/graph/node_array.h>
#include<LEDA/graph/graph_alg.h>

using namespace leda;
using namespace std;

#define SIZE 500
#define N 15

double loop(graph& G,int n,double dis[SIZE][SIZE]);
double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d);
double min_cost(double dis[SIZE][SIZE],int n);
double max_cost(double dis[SIZE][SIZE],int n);

int main()
{
  int i,j;
  double dis[SIZE][SIZE];
  char B[N][N];
  double minimum,maximum,G_cost,G_ST;

  ifstream fi;
  fi.open("nj/book-fileout/sjis-fileout");


  for(i=0;i<N;i++){
    for(j=0;j<N;j++){
      if(i==j){
	dis[i][j]=0;
	//cout << dis[i][j] <<' ';
      }else{
	//fi>>B[0];
	//fi>>B[0];
	fi>>dis[i][j];
	//cout << dis[i][j] <<' ';
      }
    }
    // putchar('\n');
  }

  fi.close();
  

  GRAPH<int,int> G;
  G.read("nj/book-gw/book-nj-sjis.gw");

  
  minimum=min_cost(dis,N);
  maximum=max_cost(dis,N);
 
  G_cost=loop(G,N,dis);
  G_ST=(G_cost-maximum) / (minimum-maximum);


  cout << "Graph G's S(T):" << G_ST << endl; 

  return 0;
}
double loop(graph& G,int n,double dis[SIZE][SIZE]){
  int a,b,c,d;
  double cost=0;

  for(a=0;a<n-3;a++){
    for(b=a+1;b<n-2;b++){
      for(c=b+1;c<n-1;c++){
	for(d=c+1;d<n;d++){
	  cost=cost+quartet_cost(G,n,dis,a,b,c,d);
	}
      }
    }
  }

  return(cost);
}

double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d){
  int a_to[SIZE]={0};
  int d_to[SIZE]={0};
  int i=0,j=0;
  int x=0,y=0;
  double q_cost;
  edge_array<int> cost(G,1);
  node_array<int> dist_a(G,MAXINT);
  node_array<int> dist_d(G,MAXINT);
  node_array<edge> pred_a(G);
  node_array<edge> pred_d(G);

  node v,na,nb,nc,nd;
  forall_nodes(v,G){
    if(index(v)==a){
      na=v;
    }else if(index(v)==b){
      nb=v;
    }else if(index(v)==c){
      nc=v;
    }else if(index(v)==d){
      nd=v;
    }
  }
  DIJKSTRA(G,na,cost,dist_a,pred_a);
  DIJKSTRA(G,nd,cost,dist_d,pred_d);
  
  edge e;
  node u,w;
  
  /**************Check quartet (ab|cd)***************/
  
  forall_nodes(w,G){
    if(w==nb){
      u=w;
      while(e=pred_a[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	a_to[i]=index(u);
	i++;
      }
    }else if(w==nc){
      u=w;
      while(e=pred_d[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	d_to[j]=index(u);
	j++;
      }
    }
  }
  
  for(i=0;i<dist_a[nb];i++){
    for(j=0;j<dist_d[nc];j++){
      if(a_to[i]==d_to[j]){
	x=1;
	break;
      }
    }
    if(x){break;}
  }

  /**************Check quartet (ab|cd)***************/
  i=0;
  j=0;
  /**************Check quartet (ac|bd)***************/

  forall_nodes(w,G){
    if(w==nc){
      u=w;
      while(e=pred_a[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	a_to[i]=index(u);
	i++;
      }
    }else if(w==nb){
      u=w;
      while(e=pred_d[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	d_to[j]=index(u);
	j++;
      }
    }
  }

  for(i=0;i<dist_a[nc];i++){
    for(j=0;j<dist_d[nb];j++){
      if(a_to[i]==d_to[j]){
	y=1;
	break;
      }
    }
    if(y){break;}
  }

  /**************Check quartet (ac|bd)***************/

  if(x==1 && y==1){
    q_cost=dis[a][d]+dis[b][c];
  }else if(x==0){
    q_cost=dis[a][b]+dis[c][d];
  }else if(y==0){
    q_cost=dis[a][c]+dis[b][d];
  }else{
    cout << "Error!!" << endl;
  }

  return(q_cost);
}
double min_cost(double dis[][SIZE],int n){
  int i,j,k,l;
  double min=0,tmp;

  for(i=0;i<n-3;i++){
    for(j=i+1;j<n-2;j++){
      for(k=j+1;k<n-1;k++){
	for(l=k+1;l<n;l++){
	  tmp=dis[i][j]+dis[k][l];
	  if(tmp>dis[i][k]+dis[j][l]){
	    tmp=dis[i][k]+dis[j][l];
	  }
	  if(tmp>dis[i][l]+dis[j][k]){
	    tmp=dis[i][l]+dis[j][k];
	  }
	  min=min+tmp;
	}
      }
    }
  }
  return(min);
}
double max_cost(double dis[][SIZE],int n){
  int i,j,k,l;
  double max=0,tmp;

  for(i=0;i<n-3;i++){
    for(j=i+1;j<n-2;j++){
      for(k=j+1;k<n-1;k++){
	for(l=k+1;l<n;l++){
	  tmp=dis[i][j]+dis[k][l];
	  if(tmp<dis[i][k]+dis[j][l]){
	    tmp=dis[i][k]+dis[j][l];
	  }
	  if(tmp<dis[i][l]+dis[j][k]){
	    tmp=dis[i][l]+dis[j][k];
	  }
	  max=max+tmp;
	}
      }
    }
  }
  return(max);
}
